// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef VISION_MSGS__MSG__DETECTION2_D__STRUCT_HPP_
#define VISION_MSGS__MSG__DETECTION2_D__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "sensor_msgs/msg/image.hpp"  // source_img
#include "std_msgs/msg/header.hpp"  // header
#include "vision_msgs/msg/bounding_box2_d.hpp"  // bbox
#include "vision_msgs/msg/object_hypothesis_with_pose.hpp"  // results

#ifndef _WIN32
# define DEPRECATED_vision_msgs_msg_Detection2D __attribute__((deprecated))
#else
# define DEPRECATED_vision_msgs_msg_Detection2D __declspec(deprecated)
#endif

namespace vision_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Detection2D_
{
  using Type = Detection2D_<ContainerAllocator>;

  explicit Detection2D_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init),
    bbox(_init),
    source_img(_init)
  {
    (void)_init;
  }

  explicit Detection2D_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    bbox(_alloc, _init),
    source_img(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
      std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _results_type =
      std::vector<vision_msgs::msg::ObjectHypothesisWithPose_<ContainerAllocator>, typename ContainerAllocator::template rebind<vision_msgs::msg::ObjectHypothesisWithPose_<ContainerAllocator>>::other>;
  _results_type results;
  using _bbox_type =
      vision_msgs::msg::BoundingBox2D_<ContainerAllocator>;
  _bbox_type bbox;
  using _source_img_type =
      sensor_msgs::msg::Image_<ContainerAllocator>;
  _source_img_type source_img;

  // setters for named parameter idiom
  Type * set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return this;
  }
  Type * set__results(
    const std::vector<vision_msgs::msg::ObjectHypothesisWithPose_<ContainerAllocator>, typename ContainerAllocator::template rebind<vision_msgs::msg::ObjectHypothesisWithPose_<ContainerAllocator>>::other> & _arg)
  {
    this->results = _arg;
    return this;
  }
  Type * set__bbox(
    const vision_msgs::msg::BoundingBox2D_<ContainerAllocator> & _arg)
  {
    this->bbox = _arg;
    return this;
  }
  Type * set__source_img(
    const sensor_msgs::msg::Image_<ContainerAllocator> & _arg)
  {
    this->source_img = _arg;
    return this;
  }

  // constants

  // pointer types
  using RawPtr =
      vision_msgs::msg::Detection2D_<ContainerAllocator> *;
  using ConstRawPtr =
      const vision_msgs::msg::Detection2D_<ContainerAllocator> *;
  using SharedPtr =
      std::shared_ptr<vision_msgs::msg::Detection2D_<ContainerAllocator>>;
  using ConstSharedPtr =
      std::shared_ptr<vision_msgs::msg::Detection2D_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vision_msgs::msg::Detection2D_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
      std::unique_ptr<vision_msgs::msg::Detection2D_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vision_msgs::msg::Detection2D_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
      std::unique_ptr<vision_msgs::msg::Detection2D_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
      std::weak_ptr<vision_msgs::msg::Detection2D_<ContainerAllocator>>;
  using ConstWeakPtr =
      std::weak_ptr<vision_msgs::msg::Detection2D_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_vision_msgs_msg_Detection2D
    std::shared_ptr<vision_msgs::msg::Detection2D_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_vision_msgs_msg_Detection2D
    std::shared_ptr<vision_msgs::msg::Detection2D_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Detection2D_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->results != other.results) {
      return false;
    }
    if (this->bbox != other.bbox) {
      return false;
    }
    if (this->source_img != other.source_img) {
      return false;
    }
    return true;
  }
  bool operator!=(const Detection2D_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Detection2D_

// alias to use template instance with default allocator
using Detection2D =
    vision_msgs::msg::Detection2D_<std::allocator<void>>;

// constants requiring out of line definition

}  // namespace msg

}  // namespace vision_msgs

#endif  // VISION_MSGS__MSG__DETECTION2_D__STRUCT_HPP_
