// generated from rosidl_generator_c/resource/msg__functions.h.em
// generated code does not contain a copyright notice

#ifndef VISION_MSGS__MSG__DETECTION2_D_ARRAY__FUNCTIONS_H_
#define VISION_MSGS__MSG__DETECTION2_D_ARRAY__FUNCTIONS_H_

#if __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "vision_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "vision_msgs/msg/detection2_d_array__struct.h"

/// Initialize vision_msgs/Detection2DArray message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(vision_msgs__msg__Detection2DArray)) before
 * or use vision_msgs__msg__Detection2DArray__create() to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
bool
vision_msgs__msg__Detection2DArray__init(vision_msgs__msg__Detection2DArray * msg);

/// Finalize vision_msgs/Detection2DArray message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
void
vision_msgs__msg__Detection2DArray__fini(vision_msgs__msg__Detection2DArray * msg);

/// Create vision_msgs/Detection2DArray message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls vision_msgs__msg__Detection2DArray__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
vision_msgs__msg__Detection2DArray *
vision_msgs__msg__Detection2DArray__create();

/// Destroy vision_msgs/Detection2DArray message.
/**
 * It calls vision_msgs__msg__Detection2DArray__fini() and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
void
vision_msgs__msg__Detection2DArray__destroy(vision_msgs__msg__Detection2DArray * msg);


/// Initialize array of vision_msgs/Detection2DArray messages.
/**
 * It allocates the memory for the number of elements and
 * calls vision_msgs__msg__Detection2DArray__init() for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
bool
vision_msgs__msg__Detection2DArray__Array__init(vision_msgs__msg__Detection2DArray__Array * array, size_t size);

/// Finalize array of vision_msgs/Detection2DArray messages.
/**
 * It calls vision_msgs__msg__Detection2DArray__fini() for each element of the array and
 * frees the memory for the number of elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
void
vision_msgs__msg__Detection2DArray__Array__fini(vision_msgs__msg__Detection2DArray__Array * array);

/// Create array of vision_msgs/Detection2DArray messages.
/**
 * It allocates the memory for the array and
 * calls vision_msgs__msg__Detection2DArray__Array__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
vision_msgs__msg__Detection2DArray__Array *
vision_msgs__msg__Detection2DArray__Array__create(size_t size);

/// Destroy array of vision_msgs/Detection2DArray messages.
/**
 * It calls vision_msgs__msg__Detection2DArray__Array__fini() on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
void
vision_msgs__msg__Detection2DArray__Array__destroy(vision_msgs__msg__Detection2DArray__Array * array);

#if __cplusplus
}
#endif

#endif  // VISION_MSGS__MSG__DETECTION2_D_ARRAY__FUNCTIONS_H_
