// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef VISION_MSGS__MSG__OBJECT_HYPOTHESIS__STRUCT_HPP_
#define VISION_MSGS__MSG__OBJECT_HYPOTHESIS__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies

#ifndef _WIN32
# define DEPRECATED_vision_msgs_msg_ObjectHypothesis __attribute__((deprecated))
#else
# define DEPRECATED_vision_msgs_msg_ObjectHypothesis __declspec(deprecated)
#endif

namespace vision_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ObjectHypothesis_
{
  using Type = ObjectHypothesis_<ContainerAllocator>;

  explicit ObjectHypothesis_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ll;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->score = 0.0;
    }
  }

  explicit ObjectHypothesis_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ll;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->score = 0.0;
    }
  }

  // field types and members
  using _id_type =
      int64_t;
  _id_type id;
  using _score_type =
      double;
  _score_type score;

  // setters for named parameter idiom
  Type * set__id(
    const int64_t & _arg)
  {
    this->id = _arg;
    return this;
  }
  Type * set__score(
    const double & _arg)
  {
    this->score = _arg;
    return this;
  }

  // constants

  // pointer types
  using RawPtr =
      vision_msgs::msg::ObjectHypothesis_<ContainerAllocator> *;
  using ConstRawPtr =
      const vision_msgs::msg::ObjectHypothesis_<ContainerAllocator> *;
  using SharedPtr =
      std::shared_ptr<vision_msgs::msg::ObjectHypothesis_<ContainerAllocator>>;
  using ConstSharedPtr =
      std::shared_ptr<vision_msgs::msg::ObjectHypothesis_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vision_msgs::msg::ObjectHypothesis_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
      std::unique_ptr<vision_msgs::msg::ObjectHypothesis_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vision_msgs::msg::ObjectHypothesis_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
      std::unique_ptr<vision_msgs::msg::ObjectHypothesis_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
      std::weak_ptr<vision_msgs::msg::ObjectHypothesis_<ContainerAllocator>>;
  using ConstWeakPtr =
      std::weak_ptr<vision_msgs::msg::ObjectHypothesis_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_vision_msgs_msg_ObjectHypothesis
    std::shared_ptr<vision_msgs::msg::ObjectHypothesis_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_vision_msgs_msg_ObjectHypothesis
    std::shared_ptr<vision_msgs::msg::ObjectHypothesis_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ObjectHypothesis_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->score != other.score) {
      return false;
    }
    return true;
  }
  bool operator!=(const ObjectHypothesis_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ObjectHypothesis_

// alias to use template instance with default allocator
using ObjectHypothesis =
    vision_msgs::msg::ObjectHypothesis_<std::allocator<void>>;

// constants requiring out of line definition

}  // namespace msg

}  // namespace vision_msgs

#endif  // VISION_MSGS__MSG__OBJECT_HYPOTHESIS__STRUCT_HPP_
